function [x]=risolvi_SVD_r(A,b,r)
% versione di TSVD con gestione troncamento dato il numero
% dei valori singolari r
n=length(b);
z=zeros(n,1);
[U,S,V]=svd(A);

% MODO 1
sigma = diag(S,0);
d=U'*b;
%i=sigma>tol;
i=logical([ones(r,1); zeros(n-r,1)]);
z(i)=d(i)./sigma(i); % solo per valori singolari >tol
x=V*z;

%disp('condizionamento del problema')
%cond=sigma(1)/sigma(n)

%% MODO 2 In alternativa
% n=size(A,2);
% x=zeros(n,1);
% k=nnz(diag(S)>tol);
% for i=1:k
%     x = x + (U(:,i)'*b)*V(:,i)/S(i,i);
% end    
