function [x]=risolvi_SVD(A,b,tol)
%% se tol==0 allora e' il metodo SVD_LS altrimenti TSVD
z=zeros(length(b),1);
[U,S,V]=svd(A);

% MODO 1
sigma = diag(S,0);
d=U'*b;
i=sigma>tol;
z(i)=d(i)./sigma(i); % solo per valori singolari >tol
x=V*z;

%disp('condizionamento del problema')
%cond=sigma(1)/sigma(n)

%% MODO 2 In alternativa
% n=size(A,2);
% x=zeros(n,1);
% k=nnz(diag(S)>tol);
% for i=1:k
%     x = x + (U(:,i)'*b)*V(:,i)/S(i,i);
% end    
